Subject: bug#44483: 27.1.50; Window parameter `min-margins' doesn't split window in half

From: martin rudalics <[email-masked]>
Date: Mon, 9 Nov 2020 09:31:20 +0100

> AFAIR, the first time I heard about the `min-margins' parameter was when I
 > looked at the release notes of Emacs 25 after it came out. I don't remember why
 > I didn't try it out immediately, but after that, I probably forgot about it,
 > until a bug report I got a week ago.
 >
 > Paul Rankin did add `min-margins' to his `olivetti' package, but he didn't
 > remove the pre-25 workaround that uses the `split-window' window parameter, so
 > the problem probably never showed up.

You're right.  It was Paul, who said that he didn't need 'min-margins'
and never reported whether they worked at all.  Sorry for the confusion
but I lost my recordings of past conversations.

 >> In Emacs 28 I intend to remove sanity checks entirely and always
 >> auto-shrink margins when they don't fit into a window any more.  Windows
 >> will also have a configurable minimum body width so the behavior seen
 >> now where the entire buffer text disappears can be easily avoided.
 >
 > OK, so yet another way of doing things. :-) Sounds like it would make my life a
 > little easier, though.

It's pretty hard to accommodate all expectations here.  Consider a user
who wants line numbers to remain visible even if everything else has
disappeared after a window has shrunk: With line numbers displayed in
margins, margins should prevail.  With display-line-numbers, buffer text
should prevail.  A minimum body width will help users to make that
decision.  Yet users still have to interfere "manually" in order to
communicate their intentions to Emacs.

 > Feel free to let me know when you implement it. I don't normally follow
 > development that closely, but in this case I'd be interested to test the new way
 > of doing things before the official release.

I'll send you a patch as soon as I consider it stable enough.

martin